      SUBROUTINE COMPB (N,IERROR,AN,BN,CN,B,AH,BH)                      POI04392
C
C     COMPB COMPUTES THE ROOTS OF THE B POLYNOMIALS USING THE EISPACK
C     SUBROUTINE IMTQL1.  IERROR IS SET TO 4 IF IF EITHER IMTQL1 FAILS
C     OR IF A(J+1)*C(J) IS LESS THAN ZERO FOR SOME J.
C     AH,BH ARE TEMPORARY WORK ARRAYS
C
      DIMENSION       AN(1)      ,BN(1)      ,CN(1)      ,B(1)       ,
     1                AH(1)      ,BH(1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NCMPLX     ,IK         ,IZ
      EPS = APXEPS(DUM)
      BNORM = ABS(BN(1))
      DO 101 J=2,N
         BNORM = AMAX1(BNORM,ABS(BN(J)))
  101 CONTINUE
      CNV = EPS*BNORM
      DO 107 J=1,N
         IF (J-1) 103,102,103
  102    IF (NPP) 107,103,107
  103    ARG = AN(J)*CN(J)
         IF (ARG) 126,104,104
  104    CHLD = SQRT(ARG)
         IF (CN(J)) 106,105,105
  105    B(J) = CHLD
         GO TO 107
  106    B(J) = -CHLD
  107 CONTINUE
      IF = 2**K
      LH = IF
      LH1 = IF+1
      I1 = 1
      DO 119 L=1,K
         I1 = I1+I1
         NN = I1+I1-1
         IFL = IF-I1+1
         DO 118 I=1,IFL,I1
            IF (I-IFL) 113,108,108
  108       IF (NPP) 109,110,109
  109       LH = LH+NN
            GO TO 118
  110       LS = 0
            DO 111 J=I,IF
               LS = LS+1
               BH(LS) = BN(J)
               AH(LS) = B(J)
  111       CONTINUE
            I1M = I1-1
            DO 112 J=1,I1M
               LS = LS+1
               BH(LS) = BN(J)
               AH(LS) = B(J)
  112       CONTINUE
            GO TO 115
  113       LS = 0
            JFL = I+NN-1
            DO 114 J=I,JFL
               LS = LS+1
               BH(LS) = BN(J)
               AH(LS) = B(J)
  114       CONTINUE
  115       CALL TQLRAT (NN,BH,AH,IERROR)
            IF (IERROR) 126,116,126
  116       DO 117 J=1,NN
               LH = LH+1
               B(LH) = -BH(J)
  117       CONTINUE
  118    CONTINUE
         LH1 = LH+1
  119 CONTINUE
      DO 120 J=1,N
         B(J) = -BN(J)
  120 CONTINUE
      IF (NPP) 125,121,125
  121 J2 = 2*N*(K-1)+4
      LH = J2
      J1 = J2-N-N+1
      N2M2 = J2+N+N-4
  122 D1 = ABS(B(J1)-B(J2-1))
      D2 = ABS(B(J1)-B(J2))
      D3 = ABS(B(J1)-B(J2+1))
      IF ((D2 .LT. D1) .AND. (D2 .LT. D3)) GO TO 123
      B(LH) = B(J2)
      J2 = J2+1
      LH = LH+1
      IF (J2-N2M2) 122,122,124
  123 J2 = J2+1
      J1 = J1+1
      IF (J2-N2M2) 122,122,124
  124 B(LH) = B(N2M2+1)
      J1 = 2*N*(K-1)+3
      J2 = J1+N+N+N
      J3 = J2+N
      CALL PPADD (N,IERROR,AN,CN,B(J1),B(J1),B(J2),B(J3))
  125 RETURN
  126 IERROR = 4
      RETURN
      END
